/*
 * ShapeFactory.hpp
 *
 *  Created on: Sep 5, 2012
 *      Author: ankele
 */

#ifndef SHAPEFACTORY_HPP_
#define SHAPEFACTORY_HPP_


// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "CodePatterns/Singleton.hpp"

class ShapeFactory : public Singleton<ShapeFactory>
{
  friend class Singleton<ShapeFactory>;

public:
  enum ShapeType{
    SPHERE, CUBE, CYLINDER, SHAPETYPES_MAX
  };

  ShapeType getShapeByName(const std::string &name);
  std::string getShapeName(ShapeType type);

private:
  // private constructor and destructor due to singleton
  ShapeFactory();
  virtual ~ShapeFactory();

  static const char *shapeNames[];
  typedef std::map<ShapeType, std::string> ShapeNameMap;
  ShapeNameMap shapeNameMap;
  typedef std::map<std::string,ShapeType> NameShapeMap;
  NameShapeMap nameShapeMap;
};

#endif /* SHAPEFACTORY_HPP_ */
